#!/bin/bash
#
# Ex.Jacky
# https://www.opencli.com/linux/shell-script-load-avg-high-auto-run-command

# 依序為 Load上限、通知信箱、主機名稱、平均Load
#loadlimit='100'
loadlimit='40'
#toemail='support@twnoc.net'
toemail='jacky@host.com.tw'
host=`hostname -f`
loadavg=`cat /proc/loadavg | awk {'print $1'} | cut -d "." -f1`

# 如果 平均Load 大於 Load上限，終止備份程序，後續寄信給工程師
if [ $loadavg -ge $loadlimit ]
then

    # get backup process pid
    ps aux | grep 'backup.py' | grep -v grep | awk '{print $2}' > /tmp/process_id
    ps aux | grep '\/scripts\/pkgacct' | grep '\/backup\/cpbackup\/daily' | awk '{print $2}' >> /tmp/process_id
    ps aux | grep '\/usr\/bin\/rsync' | grep '\/backup\/cpbackup\/daily' | awk '{print $2}' >> /tmp/process_id

    # get backup process detail
    echo "The Load Average of $host reached $loadavg , Kill the following process :" > /tmp/process
    echo '' >> /tmp/process
    ps aux | grep 'backup.py' | grep -v grep >> /tmp/process
    ps aux | grep '\/scripts\/pkgacct' | grep '\/backup\/cpbackup\/daily' >> /tmp/process
    ps aux | grep '\/usr\/bin\/rsync' | grep '\/backup\/cpbackup\/daily' >> /tmp/process
    echo '' >> /tmp/process

    # kill backup process
    #filename='/tmp/process_id'
    #exec < $filename
    #while read line
    #do
    #kill -9 "$line"
    #done

    # Send mail connect SE
    cat /tmp/process | mutt -s "$host : Load Average Alert" $toemail
fi
